// insert squad with emotionum
var _emo_layout = ''; /* tactic,list,team : default is list*/
var _emo_teamid = '';
var _emo_limit = 'all'; /* all, matchday */
var _emo_style = 'img'; /* img,sedcard1,sedcard2,sedcard3,svgteaser,svg*/
var _emo_team_container;
var _init = function () {
	_emo_team_container = document.getElementsByClassName('emo_team');
	// loop each container
	for(key in _emo_team_container){
		if (String(parseInt(key, 10)) === key && _emo_team_container.hasOwnProperty(key)) {
			_emo_team_id = _emo_team_container[key].dataset.teamid;
			_emo_limit = _emo_team_container[key].dataset.limit;
			_emo_layout = _emo_team_container[key].dataset.layout;
			_emo_style = _emo_team_container[key].dataset.style || 'sedcard1';
			renderLayout(_emo_team_container[key], _emo_layout, _emo_team_id, _emo_limit,_emo_style);
		}
	};
}

document.addEventListener('DOMContentLoaded', _init, false);


// helper functions
function renderLayout(container,layout,team_id,limit,style) {
	// first get teamdata
	var sedcard, sedcards = [], j = 0, sorted = [], toSort = 0;
	var json_obj = JSON.parse(Get('https://api.emotionum.com/_json/?network_id='+team_id));
	var json_team = json_obj.formation;
	var sedcard = getSedcard(layout,style);
	// setting up sedcard
	for (var i = 0; i <= json_obj.items.length; i++) {
		var r = json_obj.items[i];
		var formation = '';
		var def = '';
		if(typeof(r) === 'object') {
			var sort = i;
			if(limit=='matchday'){
				var pos = getKeys(json_team,'id',r);
				r.pos = (pos) ? pos[0].pos : false;
				if(!r.pos) {
					var pos = getKeys(json_team,'id','null');
					r.pos = (pos) ? pos[0].pos : false;
					if(r.pos) {
						r.caption = pos[0].name;
						r.id = r.img = r.sedcard1 = r.popuplink = 0;
						r.img = 'https://football.emotionum.com/core/export/object-card/emotionum-solo/0';
					}
				}
				if(!r.pos) continue;
				delete json_team[pos[0].pos];
				var sort = parseInt(r.pos.replace ( /[^\d.]/g, '' ));
				toSort = 1;
				formation = 'tactic'+json_team.tactic;
				r.def = pos[0].def;
				
			}

			j++;
			if(j>6) j=1;
			var find = ['[[id]]', '[[sort]]', '[[def]]', '[[formation]]','[[img]]','[[caption]]','[[svg]]','[[svgteaser]]','[[sedcard1]]','[[sedcard2]]','[[sedcard3]]','[[birthdate]]','[[country]]','[[position]]','[[popuplink]]','[[link]]','[[rel]]','[[x]]'];
			var replace = [r.id, sort, r.def, formation ,r.img, r.caption, r.svg, r.svgteaser, r.sedcard1, r.sedcard2, r.sedcard3, r.birthdate, r.country, r.position, r.popuplink, r.link, 'emo_lightbox',j];
			sedcards[sort] = [sedcard.replaceArray(find, replace),r.def, formation];
		}
	}
	// clear container
	container.innerHTML = '';
	// sorting
	if(toSort) {
		if(layout=='team' || layout == 'tactic') sorted = {};
		Object.keys(sedcards).sort().forEach(function(key) {
			  var sortkey = key;
			  if(layout=='team' || layout == 'tactic') {
				  sortkey = sedcards[key][1];
			  }
			  sorted[''+sortkey+''] = sedcards[key][0];
			});
		sedcards = sorted;
	} else {
		sedcards = sedcards.map(function(item,index){return item[0];});
	}
	if(layout == 'tactic') {
		// get a formation layout
		sedcards = sedcardsFormation(sedcards,formation);
	} else {
		sedcards = sedcards.join(' ');
	}
	// finally put it together
	appendStringAsNodes(container, sedcards);
}

function appendStringAsNodes(element, html) {
	
    var frag = document.createDocumentFragment(),
        tmp = document.createElement('body'), child;
    tmp.innerHTML = html.replace('undefined',''); //ugly
    // Append elements in a loop to a DocumentFragment, so that the browser does
    // not re-render the document for each node
    while (child = tmp.firstChild) {
        frag.appendChild(child);
    }
    element.appendChild(frag); // Now, append all elements at once
    frag = tmp = null;
}

function Get(yourUrl){
	var Httpreq = new XMLHttpRequest(); // a new request
	Httpreq.open("GET",yourUrl,false);
	Httpreq.send(null);
	return Httpreq.responseText; 

}

String.prototype.replaceArray = function(find, replace) {
	  var replaceString = this;
	  for (var i = 0; i < find.length; i++) {
		  var re = new RegExp(find[i].replace(/([.?*+^$[\]\\(){}|-])/g, "\\$1"), 'g');
	    replaceString = replaceString.replace(re, replace[i]);
	  }
	  return replaceString;
};

function getKeys(obj, prop, val){
	var keys = [];
	if (val.id=='null') val.id = null;
    for (var key in obj) {
    	if(!obj[key]) continue;
        if (obj[key].hasOwnProperty(prop) && (obj[key][prop] == val.id || obj[key]['name'] == val.caption)) {
        	obj[key]['pos'] = key;
        	keys.push(obj[key]);
        	break;
        }     
    }
    if(keys.length) return keys;
    else return false;
};

function sedcardsFormation(cards,formation) {
	var field = '<div class="emo_team_inner"><table class="emo_formation_field">' +
				'<tr><td>&nbsp</td><td>&nbsp</td><td>'+cards.TH+'</td><td>&nbsp</td><td>&nbsp</td></tr>' +
				'<tr><td>'+cards.RV+'</td><td>'+cards.IVR+'</td><td>'+cards.IVM+'</td><td>'+cards.IVL+'</td><td>'+cards.LV+'</td></tr>' +
				'<tr><td></td><td>'+cards.DMR+'</td><td>'+cards.DMM+'</td><td>'+cards.DML+'</td><td></td></tr>' +
				'<tr><td>'+cards.RM+'</td><td>'+cards.ZMR+'</td><td>'+cards.ZMM+'</td><td>'+cards.ZML+'</td><td>'+cards.LM+'</td></tr>' +
				'<tr><td>'+cards.RA+'</td><td>[[]]</td><td>'+cards.OMM+'</td><td>[[]]</td><td>'+cards.LA+'</td></tr>' +
				'<tr><td></td><td>'+cards.STR+'</td><td>'+cards.STM+'</td><td>'+cards.STL+'</td><td></td></tr>' +
				'<tr class="bank"><td colspan="5">'+cards.B2+' '+cards.B2+' '+cards.B3+' '+cards.B4+'</td></tr>' +
				'</table></div>' +
				'';
	return field.replaceArray(['undefined','[[]]'],['&nbsp;','&nbsp;'])
}

function getSedcard(layout,style) {
	var sedcardstyle = style || 'sedcard1';
	if(style == 'img' && layout != 'tactic') {layout = 'image'};
	
	switch (layout) {
		case 'team':
			// select all active players
			var sedcard = '<div class="emo_sedcard '+sedcardstyle+' sort[[sort]] [[def]] [[formation]]"><a class="emo_sedcardlink" href="[[popuplink]]" rel="[[rel]]"><img src="[['+sedcardstyle+']]" alt="[[caption]]" width="100%"></a></div>';
			break;
		case 'list':
			//
			var sedcard = '<div class="emo_sedcard list sort[[sort]] [[def]] [[formation]]"><a class="emo_sedcardlink" href="[[popuplink]]" rel="[[rel]]"><div class="emo_small" style="background-image: URL(https://football.emotionum.com/core/export/object-card/emotionum-solo/[[id]])"></div><h3>[[caption]]</h3><p>[[birthdate]] | [[position]] ([[def]]) | [[country]]</p></a></div>';
			break;
		case 'cards':
			//
			var sedcard = '<div class="emo_sedcard '+sedcardstyle+' sort[[sort]] [[def]] [[formation]]"><a class="emo_sedcardlink" href="[[popuplink]]" rel="[[rel]]"><img src="[['+sedcardstyle+']]" alt="[[caption]]" width="100%"></a></div>';
			break;
		case 'tactic':
			var sedcard = '<div class="emo_sedcard tactic sort[[sort]] [[def]] [[formation]]"><a class="emo_sedcardlink" href="[[popuplink]]" rel="[[rel]]"><div class="img"><img src="[[img]]" width="100%"></div><center><div class="h2">[[caption]]</div></center><div class="emo_container"><div class="emo_small" style="background-image: URL(https://football.emotionum.com/core/export/object-card/emotionum-solo/[[id]])"></div></div></a></div>';
			break;
		case 'image':
			var sedcard = '<div class="emo_sedcard '+sedcardstyle+' sort[[sort]] [[def]] [[formation]]"><a class="emo_sedcardlink" href="[[popuplink]]" rel="[[rel]]"><div class="img"><img src="[[img]]" width="100%"></div><div class="emo_container"><div class="emo_small" style="background: transparent URL(https://football.emotionum.com/core/export/object-card/emotionum-solo/[[id]]) no-repeat;width: 100%;height: 100%;background-size: cover;"></div></div><div class="emo_slogan" title="">Emotionum</div><h3>[[caption]]</h3></a></div>';
			break;
		default:
			var sedcard = '<div class="emo_sedcard list sort[[sort]] [[def]] [[formation]]"><a class="emo_sedcardlink" href="[[popuplink]]" rel="[[rel]]"><div class="emo_small" style="background-image: URL(https://football.emotionum.com/core/export/object-card/emotionum-solo/[[id]])"></div><h3>[[caption]]</h3><p>[[birthdate]] | [[position]] ([[def]]) | [[country]]</p></a></div>';
			break;
	}
	return sedcard;
}